#if SWIGVERSIONMINOR == 1 && SWIGVERSIONMAJOR == 1
%title "Tcl ODBC"
#endif
%module Tclodbc
%{ 
#include <stdio.h>
#include <strings.h>
#include <string.h>
#ifdef HAVE_IODBC                       // Using the free IODBC driver
/* I am not sure what version this is...
#include <iodbc.h>
#include <isql.h>
#include <isqlext.h>*/
/* iODBC 2.12 */
#include <isql.h>
#include <isqlext.h>
#else
#include <sql.h>
#include <sqlext.h>
#endif

#ifndef TRUE
#define TRUE (1)
#endif
#ifndef FALSE
#define  FALSE (0)
#endif
#include <database.h>
#include <connection.h>
#include <statement.h>
static char rcsid[] = "$Id$";
typedef int Tcl_Result;
%}



%include typemaps.i

#if SWIGVERSIONMINOR == 1 && SWIGVERSIONMAJOR == 1
%init %{
	if (Tcl_InitStubs(interp, "8.0", 0) == NULL) {
	    return TCL_ERROR;
	}
	Tcl_PkgProvide(interp,PACKAGE_NAME,PACKAGE_VERSION);
%}
#else
%{
#undef SWIG_name
#define SWIG_name PACKAGE_NAME
#undef SWIG_version
#define SWIG_version PACKAGE_VERSION
%}
#endif

%typemap(tcl8,out) Tcl_Result {
#if SWIGVERSIONMINOR == 1 && SWIGVERSIONMAJOR == 1
 return $source;
#else
 return $1;
#endif
}

%typemap(tcl8,in) Tcl_Obj * {
#if SWIGVERSIONMINOR == 1 && SWIGVERSIONMAJOR == 1
	$target = $source;
#else
	$1 = $input;
#endif
}

/*
 * Type map to handle error messages.  Hide this parameter from Tcl, but return
 * it as a second result, returning TCL_ERROR, if there is an error message.
 */

#if SWIGVERSIONMINOR == 1 && SWIGVERSIONMAJOR == 1
%typemap(tcl8,ignore) char **outmessage {
	$target = Tcl_Alloc(sizeof(char*));
	*$target = NULL;
}
#else
%typemap(tcl8,in,numinputs=0) char **outmessage {
	$1 = Tcl_Alloc(sizeof(char*));
	*$1 = NULL;
}
#endif

%typemap(tcl8,argout) char **outmessage {
#if SWIGVERSIONMINOR == 1 && SWIGVERSIONMAJOR == 1
	if (*$source != NULL) {
		int mlen = strlen(*$source);
		if (Tcl_ListObjAppendElement(interp,tcl_result,Tcl_NewStringObj(*$source,mlen)) != TCL_OK) {
			Tcl_Free(*$source);
			Tcl_Free($source);
			return TCL_ERROR;
		}
		Tcl_Free(*$source);
		Tcl_Free($source);
		return TCL_ERROR;
	}
	Tcl_Free($source);
#else
	Tcl_Obj * tcl_result = $result;
	if (*$1 != NULL) {
		int mlen = strlen(*$1);
		if (Tcl_ListObjAppendElement(interp,tcl_result,Tcl_NewStringObj(*$1,mlen)) != TCL_OK) {
			Tcl_Free(*$1);
			Tcl_Free($1);
			return TCL_ERROR;
		}
		Tcl_Free(*$1);
		Tcl_Free($1);
		return TCL_ERROR;
	}
	Tcl_Free($1);
#endif
}





%{
static void extract_error(const char *command,
			   SQLHANDLE handle,SQLSMALLINT type,char **output)  {
		SQLINTEGER	 i = 0;
		SQLINTEGER	 native;
		SQLCHAR	 state[ 7 ];
		SQLCHAR	 text[256];
		SQLSMALLINT	 len;
		SQLRETURN	 ret;
		Tcl_DString result;
		char nbuffer[TCL_INTEGER_SPACE];

		Tcl_DStringInit(&result);
		Tcl_DStringAppend(&result,command,-1);
		Tcl_DStringAppend(&result,": ",-1);
		do {
			ret = SQLGetDiagRec(type, handle, ++i, state, &native, text,
					    sizeof(text), &len );
			if (SQL_SUCCEEDED(ret)) {
				Tcl_DStringStartSublist(&result);
				Tcl_DStringAppendElement(&result,state);
				sprintf(nbuffer,"%lu",i);
				Tcl_DStringAppendElement(&result,nbuffer);
				sprintf(nbuffer,"%lu",native);
				Tcl_DStringAppendElement(&result,nbuffer);
				Tcl_DStringAppendElement(&result,text);
				Tcl_DStringEndSublist(&result);
			}
		} while( ret == SQL_SUCCESS );
		if (output != NULL) {
		    *output = Tcl_Alloc(Tcl_DStringLength(&result)+1);
		    strcpy(*output,Tcl_DStringValue(&result));
		}
	        Tcl_DStringFree(&result);
	}
static void extract_error_tointerp(const char *command,
			   SQLHANDLE handle,SQLSMALLINT type,Tcl_Interp *interp) {
		SQLINTEGER	 i = 0;
		SQLINTEGER	 native;
		SQLCHAR	 state[ 7 ];
		SQLCHAR	 text[256];
		SQLSMALLINT	 len;
		SQLRETURN	 ret;
		Tcl_DString result;
		char nbuffer[TCL_INTEGER_SPACE];

		Tcl_DStringInit(&result);
		Tcl_DStringAppend(&result,command,-1);
		Tcl_DStringAppend(&result,": ",-1);
		do {
			ret = SQLGetDiagRec(type, handle, ++i, state, &native, text,
					    sizeof(text), &len );
			if (SQL_SUCCEEDED(ret)) {
				Tcl_DStringStartSublist(&result);
				Tcl_DStringAppendElement(&result,state);
				sprintf(nbuffer,"%lu",i);
				Tcl_DStringAppendElement(&result,nbuffer);
				sprintf(nbuffer,"%lu",native);
				Tcl_DStringAppendElement(&result,nbuffer);
				Tcl_DStringAppendElement(&result,text);
				Tcl_DStringEndSublist(&result);
			}
		} while( ret == SQL_SUCCESS );
		Tcl_SetObjResult(interp,Tcl_NewStringObj(Tcl_DStringValue(&result),Tcl_DStringLength(&result)));
	        Tcl_DStringFree(&result);
	}
%}

%nodefault;
%include statement.i
%include connection.i
%include database.i
